import 'dart:async';

class Store<T> {
  static dynamic _state;
  static StreamController controller;
  static Stream stream;

  static T getState<T>() {
    return _state;
  }

  static T setState<T>(Function(T state) fn) {
    fn(_state);
    controller.add(_state);
    return _state;
  }

  static void initState<T>(T state) {
    _state = state;
    controller = StreamController.broadcast();
    stream = controller.stream;
    stream.listen((data) {
      _state = data;
    });
  }
}
